diff --git a/src/compiler/nir/nir_lower_int_to_float.c b/src/compiler/nir/nir_lower_int_to_float.c
index e7c935f64ff..dc107de07e5 100644
--- a/src/compiler/nir/nir_lower_int_to_float.c
+++ b/src/compiler/nir/nir_lower_int_to_float.c
@@ -297,11 +297,7 @@ nir_lower_int_to_float_impl(nir_function_impl *impl)
       }
    }
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
+   nir_progress(progress, impl, nir_metadata_control_flow);
 
    free(float_types);
    free(int_types);
diff --git a/src/compiler/nir/nir_lower_io.c b/src/compiler/nir/nir_lower_io.c
index 09c87d8ee84..71c4fb5fe4b 100644
--- a/src/compiler/nir/nir_lower_io.c
+++ b/src/compiler/nir/nir_lower_io.c
@@ -876,7 +876,7 @@ nir_lower_io_impl(nir_function_impl *impl,
 
    ralloc_free(state.dead_ctx);
 
-   nir_metadata_preserve(impl, nir_metadata_none);
+   nir_progress(true, impl, nir_metadata_none);
 
    return progress;
 }
@@ -2473,13 +2473,7 @@ nir_lower_explicit_io_impl(nir_function_impl *impl, nir_variable_mode modes,
       }
    }
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_none);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_none);
 }
 
 /** Lower explicitly laid out I/O access to byte offset/address intrinsics
@@ -2564,15 +2558,8 @@ nir_lower_vars_to_explicit_types_impl(nir_function_impl *impl,
       }
    }
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow |
-                                     nir_metadata_live_defs |
-                                     nir_metadata_loop_analysis);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return progress;
+   return nir_progress(progress, impl,
+                       nir_metadata_control_flow | nir_metadata_live_defs | nir_metadata_loop_analysis);
 }
 
 static bool
@@ -3131,10 +3118,7 @@ nir_io_add_const_offset_to_base(nir_shader *nir, nir_variable_mode modes)
          impl_progress |= add_const_offset_to_base_block(block, &b, modes);
       }
       progress |= impl_progress;
-      if (impl_progress)
-         nir_metadata_preserve(impl, nir_metadata_control_flow);
-      else
-         nir_metadata_preserve(impl, nir_metadata_all);
+      nir_progress(impl_progress, impl, nir_metadata_control_flow);
    }
 
    return progress;
@@ -3211,12 +3195,7 @@ nir_lower_color_inputs(nir_shader *nir)
       }
    }
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
 
 bool
@@ -3290,7 +3269,7 @@ nir_io_add_intrinsic_xfb_info(nir_shader *nir)
       }
    }
 
-   nir_metadata_preserve(impl, nir_metadata_all);
+   nir_no_progress(impl);
    return progress;
 }
 
diff --git a/src/compiler/nir/nir_lower_io_arrays_to_elements.c b/src/compiler/nir/nir_lower_io_arrays_to_elements.c
index 673e11cd5b3..14c5c4be841 100644
--- a/src/compiler/nir/nir_lower_io_arrays_to_elements.c
+++ b/src/compiler/nir/nir_lower_io_arrays_to_elements.c
@@ -351,11 +351,7 @@ lower_io_arrays_to_elements(nir_shader *shader, nir_variable_mode mask,
          }
       }
 
-      if (progress) {
-         nir_metadata_preserve(impl, nir_metadata_control_flow);
-      } else {
-         nir_metadata_preserve(impl, nir_metadata_all);
-      }
+      nir_progress(progress, impl, nir_metadata_control_flow);
    }
 }
 
diff --git a/src/compiler/nir/nir_lower_io_to_temporaries.c b/src/compiler/nir/nir_lower_io_to_temporaries.c
index 8c7b0809bdd..f4cb0ff5891 100644
--- a/src/compiler/nir/nir_lower_io_to_temporaries.c
+++ b/src/compiler/nir/nir_lower_io_to_temporaries.c
@@ -340,8 +340,7 @@ nir_lower_io_to_temporaries(nir_shader *shader, nir_function_impl *entrypoint,
        shader->info.stage != MESA_SHADER_TESS_EVAL &&
        shader->info.stage != MESA_SHADER_GEOMETRY &&
        shader->info.stage != MESA_SHADER_FRAGMENT) {
-      nir_metadata_preserve(entrypoint, nir_metadata_all);
-      return false;
+      return nir_no_progress(entrypoint);
    }
 
    state.shader = shader;
@@ -381,7 +380,7 @@ nir_lower_io_to_temporaries(nir_shader *shader, nir_function_impl *entrypoint,
       if (outputs)
          emit_output_copies_impl(&state, impl);
 
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
+      nir_progress(true, impl, nir_metadata_control_flow);
    }
 
    exec_list_append(&shader->variables, &state.old_inputs);
diff --git a/src/compiler/nir/nir_lower_io_to_vector.c b/src/compiler/nir/nir_lower_io_to_vector.c
index ef54b3c5268..d96ff048094 100644
--- a/src/compiler/nir/nir_lower_io_to_vector.c
+++ b/src/compiler/nir/nir_lower_io_to_vector.c
@@ -596,11 +596,7 @@ nir_lower_io_to_vector_impl(nir_function_impl *impl, nir_variable_mode modes)
    nir_fixup_deref_modes(b.shader);
    util_dynarray_fini(&demote_vars);
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   }
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
 
 bool
diff --git a/src/compiler/nir/nir_lower_load_const_to_scalar.c b/src/compiler/nir/nir_lower_load_const_to_scalar.c
index 79e2e1f5421..a8351dde71b 100644
--- a/src/compiler/nir/nir_lower_load_const_to_scalar.c
+++ b/src/compiler/nir/nir_lower_load_const_to_scalar.c
@@ -74,13 +74,7 @@ nir_lower_load_const_to_scalar_impl(nir_function_impl *impl)
       }
    }
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
 
 bool
diff --git a/src/compiler/nir/nir_lower_locals_to_regs.c b/src/compiler/nir/nir_lower_locals_to_regs.c
index d69e65773f5..cb3b0e39c36 100644
--- a/src/compiler/nir/nir_lower_locals_to_regs.c
+++ b/src/compiler/nir/nir_lower_locals_to_regs.c
@@ -301,7 +301,7 @@ impl(nir_function_impl *impl, uint8_t bool_bitsize)
       lower_locals_to_regs_block(block, &state);
    }
 
-   nir_metadata_preserve(impl, nir_metadata_control_flow);
+   nir_progress(true, impl, nir_metadata_control_flow);
 
    _mesa_hash_table_destroy(state.regs_table, NULL);
 
diff --git a/src/compiler/nir/nir_lower_mediump.c b/src/compiler/nir/nir_lower_mediump.c
index 2114007e719..ffbcec341a9 100644
--- a/src/compiler/nir/nir_lower_mediump.c
+++ b/src/compiler/nir/nir_lower_mediump.c
@@ -147,11 +147,7 @@ nir_recompute_io_bases(nir_shader *nir, nir_variable_mode modes)
       }
    }
 
-   if (changed) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
+   nir_progress(changed, impl, nir_metadata_control_flow);
 
    if (modes & nir_var_shader_in)
       nir->num_inputs = BITSET_COUNT(inputs);
@@ -285,13 +281,7 @@ nir_lower_mediump_io(nir_shader *nir, nir_variable_mode modes,
    if (changed && use_16bit_slots)
       nir_recompute_io_bases(nir, modes);
 
-   if (changed) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return changed;
+   return nir_progress(changed, impl, nir_metadata_control_flow);
 }
 
 /**
@@ -346,13 +336,7 @@ nir_force_mediump_io(nir_shader *nir, nir_variable_mode modes,
       }
    }
 
-   if (changed) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return changed;
+   return nir_progress(changed, impl, nir_metadata_control_flow);
 }
 
 /**
@@ -391,13 +375,7 @@ nir_unpack_16bit_varying_slots(nir_shader *nir, nir_variable_mode modes)
    if (changed)
       nir_recompute_io_bases(nir, modes);
 
-   if (changed) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return changed;
+   return nir_progress(changed, impl, nir_metadata_control_flow);
 }
 
 static bool
@@ -557,13 +535,7 @@ nir_lower_mediump_vars_impl(nir_function_impl *impl, nir_variable_mode modes,
       }
    }
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
 
 bool
diff --git a/src/compiler/nir/nir_lower_memcpy.c b/src/compiler/nir/nir_lower_memcpy.c
index 9c4557faaea..59545467b2d 100644
--- a/src/compiler/nir/nir_lower_memcpy.c
+++ b/src/compiler/nir/nir_lower_memcpy.c
@@ -176,12 +176,8 @@ lower_memcpy_impl(nir_function_impl *impl)
    }
 
    if (found_non_const_memcpy) {
-      nir_metadata_preserve(impl, nir_metadata_none);
-   } else if (found_const_memcpy) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
+      nir_progress(true, impl, nir_metadata_none);
+   } else nir_progress(found_const_memcpy, impl, nir_metadata_control_flow);
 
    return found_const_memcpy || found_non_const_memcpy;
 }
diff --git a/src/compiler/nir/nir_lower_memory_model.c b/src/compiler/nir/nir_lower_memory_model.c
index c797eae8a4e..c0b38ab9140 100644
--- a/src/compiler/nir/nir_lower_memory_model.c
+++ b/src/compiler/nir/nir_lower_memory_model.c
@@ -240,12 +240,8 @@ nir_lower_memory_model(nir_shader *shader)
       modes = 0;
       foreach_list_typed_reverse(nir_cf_node, cf_node, node, cf_list)
          impl_progress |= lower_make_available(cf_node, &modes);
-
-      if (impl_progress)
-         nir_metadata_preserve(impl, nir_metadata_control_flow);
-      else
-         nir_metadata_preserve(impl, nir_metadata_all);
-      progress |= impl_progress;
+      progress = progress | nir_progress(impl_progress, impl,
+                                         nir_metadata_control_flow);
    }
 
    return progress;
diff --git a/src/compiler/nir/nir_lower_multiview.c b/src/compiler/nir/nir_lower_multiview.c
index 07c90f2fc23..7b5fcd478f4 100644
--- a/src/compiler/nir/nir_lower_multiview.c
+++ b/src/compiler/nir/nir_lower_multiview.c
@@ -326,6 +326,5 @@ nir_lower_multiview(nir_shader *shader, nir_lower_multiview_options options)
 
    _mesa_hash_table_destroy(out_derefs, NULL);
 
-   nir_metadata_preserve(entrypoint, nir_metadata_none);
-   return true;
+   return nir_progress(true, entrypoint, nir_metadata_none);
 }
diff --git a/src/compiler/nir/nir_lower_non_uniform_access.c b/src/compiler/nir/nir_lower_non_uniform_access.c
index 76180ed99df..7483eb6d12b 100644
--- a/src/compiler/nir/nir_lower_non_uniform_access.c
+++ b/src/compiler/nir/nir_lower_non_uniform_access.c
@@ -451,10 +451,7 @@ nir_lower_non_uniform_access_impl(nir_function_impl *impl,
 
    _mesa_hash_table_destroy(state.accesses, NULL);
 
-   if (progress)
-      nir_metadata_preserve(impl, nir_metadata_none);
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_none);
 }
 
 /**
diff --git a/src/compiler/nir/nir_lower_passthrough_edgeflags.c b/src/compiler/nir/nir_lower_passthrough_edgeflags.c
index 09347a10fe6..6909542a191 100644
--- a/src/compiler/nir/nir_lower_passthrough_edgeflags.c
+++ b/src/compiler/nir/nir_lower_passthrough_edgeflags.c
@@ -49,7 +49,7 @@ lower_impl(nir_function_impl *impl)
                     .base = shader->num_outputs++,
                     .io_semantics.location = VARYING_SLOT_EDGE);
 
-   nir_metadata_preserve(impl, nir_metadata_control_flow);
+   nir_progress(true, impl, nir_metadata_control_flow);
 }
 
 bool
diff --git a/src/compiler/nir/nir_lower_patch_vertices.c b/src/compiler/nir/nir_lower_patch_vertices.c
index a9ee46ebfa4..72b83befd20 100644
--- a/src/compiler/nir/nir_lower_patch_vertices.c
+++ b/src/compiler/nir/nir_lower_patch_vertices.c
@@ -89,9 +89,7 @@ nir_lower_patch_vertices(nir_shader *nir,
          }
       }
 
-      if (progress) {
-         nir_metadata_preserve(impl, nir_metadata_control_flow);
-      }
+      nir_progress(progress, impl, nir_metadata_control_flow);
    }
 
    return progress;
diff --git a/src/compiler/nir/nir_lower_phis_to_scalar.c b/src/compiler/nir/nir_lower_phis_to_scalar.c
index e4245ea251b..47fadea5dfc 100644
--- a/src/compiler/nir/nir_lower_phis_to_scalar.c
+++ b/src/compiler/nir/nir_lower_phis_to_scalar.c
@@ -269,7 +269,7 @@ lower_phis_to_scalar_impl(nir_function_impl *impl, bool lower_all)
       progress = lower_phis_to_scalar_block(block, &state) || progress;
    }
 
-   nir_metadata_preserve(impl, nir_metadata_control_flow);
+   nir_progress(true, impl, nir_metadata_control_flow);
 
    nir_instr_free_list(&state.dead_instrs);
 
diff --git a/src/compiler/nir/nir_lower_pntc_ytransform.c b/src/compiler/nir/nir_lower_pntc_ytransform.c
index 7b641531b08..caf819e1787 100644
--- a/src/compiler/nir/nir_lower_pntc_ytransform.c
+++ b/src/compiler/nir/nir_lower_pntc_ytransform.c
@@ -132,7 +132,7 @@ nir_lower_pntc_ytransform(nir_shader *shader,
       nir_foreach_block(block, impl) {
          lower_pntc_ytransform_block(&state, block);
       }
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
+      nir_progress(true, impl, nir_metadata_control_flow);
    }
 
    return state.pntc_transform != NULL;
diff --git a/src/compiler/nir/nir_lower_point_size_mov.c b/src/compiler/nir/nir_lower_point_size_mov.c
index 952e17a7caa..e7139330345 100644
--- a/src/compiler/nir/nir_lower_point_size_mov.c
+++ b/src/compiler/nir/nir_lower_point_size_mov.c
@@ -86,7 +86,7 @@ nir_lower_point_size_mov(nir_shader *shader,
       lower_point_size_mov_after(&b, in);
       shader->info.outputs_written |= VARYING_BIT_PSIZ;
       progress = true;
-      nir_metadata_preserve(impl, preserved);
+      nir_progress(true, impl, preserved);
    }
    return progress;
 }
diff --git a/src/compiler/nir/nir_lower_reg_intrinsics_to_ssa.c b/src/compiler/nir/nir_lower_reg_intrinsics_to_ssa.c
index 36897f20c56..9ab9b96c74a 100644
--- a/src/compiler/nir/nir_lower_reg_intrinsics_to_ssa.c
+++ b/src/compiler/nir/nir_lower_reg_intrinsics_to_ssa.c
@@ -128,8 +128,7 @@ nir_lower_reg_intrinsics_to_ssa_impl(nir_function_impl *impl)
       }
    }
    if (!need_lower_reg) {
-      nir_metadata_preserve(impl, nir_metadata_all);
-      return false;
+      return nir_no_progress(impl);
    }
 
    nir_metadata_require(impl, nir_metadata_control_flow);
@@ -170,8 +169,7 @@ nir_lower_reg_intrinsics_to_ssa_impl(nir_function_impl *impl)
 
    ralloc_free(dead_ctx);
 
-   nir_metadata_preserve(impl, nir_metadata_control_flow);
-   return true;
+   return nir_progress(true, impl, nir_metadata_control_flow);
 }
 
 bool
diff --git a/src/compiler/nir/nir_lower_returns.c b/src/compiler/nir/nir_lower_returns.c
index d363d9a1774..7f511f7bba9 100644
--- a/src/compiler/nir/nir_lower_returns.c
+++ b/src/compiler/nir/nir_lower_returns.c
@@ -286,11 +286,11 @@ nir_lower_returns_impl(nir_function_impl *impl)
    progress = progress || state.removed_unreachable_code;
 
    if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_none);
+      nir_progress(true, impl, nir_metadata_none);
       nir_rematerialize_derefs_in_use_blocks_impl(impl);
       nir_repair_ssa_impl(impl);
    } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
+      nir_no_progress(impl);
    }
 
    return progress;
diff --git a/src/compiler/nir/nir_lower_scratch.c b/src/compiler/nir/nir_lower_scratch.c
index 3536e05d9c4..23583377f5b 100644
--- a/src/compiler/nir/nir_lower_scratch.c
+++ b/src/compiler/nir/nir_lower_scratch.c
@@ -219,12 +219,8 @@ nir_lower_vars_to_scratch(nir_shader *shader,
          }
       }
 
-      if (impl_progress) {
-         progress = true;
-         nir_metadata_preserve(impl, nir_metadata_control_flow);
-      } else {
-         nir_metadata_preserve(impl, nir_metadata_all);
-      }
+      progress = progress | nir_progress(impl_progress, impl,
+                                         nir_metadata_control_flow);
    }
 
    _mesa_set_destroy(set, NULL);
diff --git a/src/compiler/nir/nir_lower_shader_calls.c b/src/compiler/nir/nir_lower_shader_calls.c
index 46d473cb2d0..c1caec4601a 100644
--- a/src/compiler/nir/nir_lower_shader_calls.c
+++ b/src/compiler/nir/nir_lower_shader_calls.c
@@ -57,13 +57,7 @@ move_system_values_to_top(nir_shader *shader)
       }
    }
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
 
 static bool
@@ -894,7 +888,7 @@ duplicate_loop_bodies(nir_function_impl *impl, nir_instr *resume_instr)
    }
 
    if (resume_reg != NULL)
-      nir_metadata_preserve(impl, nir_metadata_none);
+      nir_progress(true, impl, nir_metadata_none);
 
    return resume_reg != NULL;
 }
@@ -1289,7 +1283,7 @@ lower_resume(nir_shader *shader, int call_idx)
 
    ralloc_free(mem_ctx);
 
-   nir_metadata_preserve(impl, nir_metadata_none);
+   nir_progress(true, impl, nir_metadata_none);
 
    nir_validate_shader(shader, "after flatten_resume_if_ladder in "
                                "nir_lower_shader_calls");
@@ -1589,10 +1583,8 @@ nir_opt_trim_stack_values(nir_shader *shader)
       }
    }
 
-   nir_metadata_preserve(impl,
-                         progress ? (nir_metadata_control_flow |
-                                     nir_metadata_loop_analysis)
-                                  : nir_metadata_all);
+   nir_progress(progress, impl,
+                nir_metadata_control_flow | nir_metadata_loop_analysis);
 
    _mesa_hash_table_u64_destroy(value_id_to_mask);
 
@@ -1834,10 +1826,8 @@ nir_opt_stack_loads(nir_shader *shader)
          }
       }
 
-      nir_metadata_preserve(impl,
-                            func_progress ? (nir_metadata_control_flow |
-                                             nir_metadata_loop_analysis)
-                                          : nir_metadata_all);
+      nir_progress(func_progress, impl,
+                   nir_metadata_control_flow | nir_metadata_loop_analysis);
 
       progress |= func_progress;
    }
diff --git a/src/compiler/nir/nir_lower_task_shader.c b/src/compiler/nir/nir_lower_task_shader.c
index 8765f25c4df..3854cf42598 100644
--- a/src/compiler/nir/nir_lower_task_shader.c
+++ b/src/compiler/nir/nir_lower_task_shader.c
@@ -143,9 +143,7 @@ nir_lower_nv_task_count(nir_shader *shader)
    nir_builder builder = nir_builder_create(impl);
 
    append_launch_mesh_workgroups_to_nv_task(&builder, &state);
-   nir_metadata_preserve(impl, nir_metadata_none);
-
-   return true;
+   return nir_progress(true, impl, nir_metadata_none);
 }
 
 static nir_intrinsic_op
@@ -446,7 +444,7 @@ nir_lower_task_shader(nir_shader *shader,
       nir_block *last_block = nir_impl_last_block(impl);
       builder.cursor = nir_after_block_before_jump(last_block);
       nir_launch_mesh_workgroups(&builder, nir_imm_zero(&builder, 3, 32));
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
+      nir_progress(true, impl, nir_metadata_control_flow);
    }
 
    bool atomics = options.payload_to_shared_for_atomics;
diff --git a/src/compiler/nir/nir_lower_terminate_to_demote.c b/src/compiler/nir/nir_lower_terminate_to_demote.c
index 03976bd3bd5..f7927eda78a 100644
--- a/src/compiler/nir/nir_lower_terminate_to_demote.c
+++ b/src/compiler/nir/nir_lower_terminate_to_demote.c
@@ -85,13 +85,7 @@ nir_lower_terminate_impl(nir_function_impl *impl)
    nir_builder b = nir_builder_create(impl);
    bool progress = nir_lower_terminate_cf_list(&b, &impl->body);
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_none);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_none);
 }
 
 /** Lowers nir_intrinsic_terminate to demote + halt
diff --git a/src/compiler/nir/nir_lower_tex.c b/src/compiler/nir/nir_lower_tex.c
index d8d67833565..fcc06f6f18f 100644
--- a/src/compiler/nir/nir_lower_tex.c
+++ b/src/compiler/nir/nir_lower_tex.c
@@ -1791,7 +1791,7 @@ nir_lower_tex_impl(nir_function_impl *impl,
       progress |= nir_lower_tex_block(block, &builder, options, compiler_options);
    }
 
-   nir_metadata_preserve(impl, nir_metadata_control_flow);
+   nir_progress(true, impl, nir_metadata_control_flow);
    return progress;
 }
 
diff --git a/src/compiler/nir/nir_lower_texcoord_replace.c b/src/compiler/nir/nir_lower_texcoord_replace.c
index 5e98f6435e8..850138db575 100644
--- a/src/compiler/nir/nir_lower_texcoord_replace.c
+++ b/src/compiler/nir/nir_lower_texcoord_replace.c
@@ -124,7 +124,7 @@ nir_lower_texcoord_replace_impl(nir_function_impl *impl,
       }
    }
 
-   nir_metadata_preserve(impl, nir_metadata_control_flow);
+   nir_progress(true, impl, nir_metadata_control_flow);
 }
 
 bool
diff --git a/src/compiler/nir/nir_lower_variable_initializers.c b/src/compiler/nir/nir_lower_variable_initializers.c
index 9ab4f53cdf1..ec3f3d1beef 100644
--- a/src/compiler/nir/nir_lower_variable_initializers.c
+++ b/src/compiler/nir/nir_lower_variable_initializers.c
@@ -120,13 +120,8 @@ nir_lower_variable_initializers(nir_shader *shader, nir_variable_mode modes)
                                                   nir_var_function_temp);
       }
 
-      if (impl_progress) {
-         progress = true;
-         nir_metadata_preserve(impl, nir_metadata_control_flow |
-                                        nir_metadata_live_defs);
-      } else {
-         nir_metadata_preserve(impl, nir_metadata_all);
-      }
+      progress = progress | nir_progress(impl_progress, impl,
+                                         nir_metadata_control_flow | nir_metadata_live_defs);
    }
 
    return progress;
@@ -201,9 +196,8 @@ nir_zero_initialize_shared_memory(nir_shader *shader,
    nir_barrier(&b, SCOPE_WORKGROUP, SCOPE_WORKGROUP, NIR_MEMORY_ACQ_REL,
                nir_var_mem_shared);
 
-   nir_metadata_preserve(nir_shader_get_entrypoint(shader), nir_metadata_none);
-
-   return true;
+   return nir_progress(true, nir_shader_get_entrypoint(shader),
+                       nir_metadata_none);
 }
 
 
@@ -297,7 +291,6 @@ nir_clear_shared_memory(nir_shader *shader,
       nir_builder_instr_insert(&b, &offset_phi->instr);
    }
 
-   nir_metadata_preserve(nir_shader_get_entrypoint(shader), nir_metadata_none);
-
-   return true;
+   return nir_progress(true, nir_shader_get_entrypoint(shader),
+                       nir_metadata_none);
 }
diff --git a/src/compiler/nir/nir_lower_vars_to_ssa.c b/src/compiler/nir/nir_lower_vars_to_ssa.c
index 2ff2a29ab0c..a6dbd3b51ce 100644
--- a/src/compiler/nir/nir_lower_vars_to_ssa.c
+++ b/src/compiler/nir/nir_lower_vars_to_ssa.c
@@ -833,8 +833,7 @@ nir_lower_vars_to_ssa_impl(nir_function_impl *impl)
    }
 
    if (!progress) {
-      nir_metadata_preserve(impl, nir_metadata_all);
-      return false;
+      return nir_no_progress(impl);
    }
 
    nir_metadata_require(impl, nir_metadata_dominance);
@@ -882,7 +881,7 @@ nir_lower_vars_to_ssa_impl(nir_function_impl *impl)
 
    nir_phi_builder_finish(state.phi_builder);
 
-   nir_metadata_preserve(impl, nir_metadata_control_flow);
+   nir_progress(true, impl, nir_metadata_control_flow);
 
    ralloc_free(state.dead_ctx);
 
diff --git a/src/compiler/nir/nir_metadata.c b/src/compiler/nir/nir_metadata.c
index 2ab2b00659f..fea93a377d0 100644
--- a/src/compiler/nir/nir_metadata.c
+++ b/src/compiler/nir/nir_metadata.c
@@ -89,7 +89,7 @@ void
 nir_shader_preserve_all_metadata(nir_shader *shader)
 {
    nir_foreach_function_impl(impl, shader) {
-      nir_metadata_preserve(impl, nir_metadata_all);
+      nir_no_progress(impl);
    }
 }
 
diff --git a/src/compiler/nir/nir_move_output_stores_to_end.c b/src/compiler/nir/nir_move_output_stores_to_end.c
index 29b34bfbcde..cd3943cb16d 100644
--- a/src/compiler/nir/nir_move_output_stores_to_end.c
+++ b/src/compiler/nir/nir_move_output_stores_to_end.c
@@ -92,7 +92,5 @@ nir_move_output_stores_to_end(nir_shader *nir)
       progress = true;
    }
 
-   nir_metadata_preserve(impl, progress ? nir_metadata_control_flow :
-                                          nir_metadata_all);
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
diff --git a/src/compiler/nir/nir_move_vec_src_uses_to_dest.c b/src/compiler/nir/nir_move_vec_src_uses_to_dest.c
index c85aa19fc2a..d10e6e28ba1 100644
--- a/src/compiler/nir/nir_move_vec_src_uses_to_dest.c
+++ b/src/compiler/nir/nir_move_vec_src_uses_to_dest.c
@@ -187,7 +187,7 @@ nir_move_vec_src_uses_to_dest_impl(nir_shader *shader, nir_function_impl *impl,
       progress |= move_vec_src_uses_to_dest_block(block, skip_const_srcs);
    }
 
-   nir_metadata_preserve(impl, nir_metadata_control_flow);
+   nir_progress(true, impl, nir_metadata_control_flow);
 
    return progress;
 }
diff --git a/src/compiler/nir/nir_opt_access.c b/src/compiler/nir/nir_opt_access.c
index 01aacec14be..a33816472c9 100644
--- a/src/compiler/nir/nir_opt_access.c
+++ b/src/compiler/nir/nir_opt_access.c
@@ -277,14 +277,8 @@ opt_access_impl(struct access_state *state,
       }
    }
 
-   if (progress) {
-      nir_metadata_preserve(impl,
-                            nir_metadata_control_flow |
-                            nir_metadata_live_defs |
-                            nir_metadata_loop_analysis);
-   }
-
-   return progress;
+   return nir_progress(progress, impl,
+                       nir_metadata_control_flow | nir_metadata_live_defs | nir_metadata_loop_analysis);
 }
 
 bool
@@ -323,12 +317,8 @@ nir_opt_access(nir_shader *shader, const nir_opt_access_options *options)
       progress |= opt_access_impl(&state, impl);
 
       /* If we make a change to the uniforms, update all the impls. */
-      if (var_progress) {
-         nir_metadata_preserve(impl,
-                               nir_metadata_control_flow |
-                               nir_metadata_live_defs |
-                               nir_metadata_loop_analysis);
-      }
+      nir_progress(var_progress, impl,
+                   nir_metadata_control_flow | nir_metadata_live_defs | nir_metadata_loop_analysis);
    }
 
    progress |= var_progress;
diff --git a/src/compiler/nir/nir_opt_barriers.c b/src/compiler/nir/nir_opt_barriers.c
index 25f228e11ea..353c33e8afc 100644
--- a/src/compiler/nir/nir_opt_barriers.c
+++ b/src/compiler/nir/nir_opt_barriers.c
@@ -70,14 +70,8 @@ nir_opt_combine_barriers_impl(nir_function_impl *impl,
       }
    }
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow |
-                                     nir_metadata_live_defs);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return progress;
+   return nir_progress(progress, impl,
+                       nir_metadata_control_flow | nir_metadata_live_defs);
 }
 
 /* Combine adjacent scoped barriers. */
@@ -234,13 +228,9 @@ nir_opt_barrier_modes(nir_shader *shader)
       nir_metadata_require(impl, nir_metadata_dominance |
                                  nir_metadata_instr_index);
 
-      if (nir_opt_barrier_modes_impl(impl)) {
-         nir_metadata_preserve(impl, nir_metadata_control_flow |
-                                     nir_metadata_live_defs);
-         progress = true;
-      } else {
-         nir_metadata_preserve(impl, nir_metadata_all);
-      }
+      bool impl_progress = nir_opt_barrier_modes_impl(impl);
+      progress = progress | nir_progress(impl_progress, impl,
+                                         nir_metadata_control_flow | nir_metadata_live_defs);
    }
 
    return progress;
diff --git a/src/compiler/nir/nir_opt_call.c b/src/compiler/nir/nir_opt_call.c
index d1f7822fefd..4a8a4f389e7 100644
--- a/src/compiler/nir/nir_opt_call.c
+++ b/src/compiler/nir/nir_opt_call.c
@@ -245,8 +245,7 @@ nir_minimize_call_live_states_impl(nir_function_impl *impl)
 
    ralloc_free(mem_ctx);
 
-   nir_metadata_preserve(impl, nir_metadata_block_index |
-                                  nir_metadata_dominance);
+   nir_progress(true, impl, nir_metadata_block_index | nir_metadata_dominance);
    return progress;
 }
 
diff --git a/src/compiler/nir/nir_opt_combine_stores.c b/src/compiler/nir/nir_opt_combine_stores.c
index a5acaae5c31..dcb88156a5a 100644
--- a/src/compiler/nir/nir_opt_combine_stores.c
+++ b/src/compiler/nir/nir_opt_combine_stores.c
@@ -401,11 +401,8 @@ combine_stores_impl(struct combine_stores_state *state, nir_function_impl *impl)
    nir_foreach_block(block, impl)
       combine_stores_block(state, block);
 
-   if (state->progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
+   bool impl_progress = state->progress;
+   nir_progress(impl_progress, impl, nir_metadata_control_flow);
 
    return state->progress;
 }
diff --git a/src/compiler/nir/nir_opt_comparison_pre.c b/src/compiler/nir/nir_opt_comparison_pre.c
index e8b5b0c7914..dbaeac8a1a1 100644
--- a/src/compiler/nir/nir_opt_comparison_pre.c
+++ b/src/compiler/nir/nir_opt_comparison_pre.c
@@ -384,13 +384,7 @@ nir_opt_comparison_pre_impl(nir_function_impl *impl)
 
    block_queue_finish(&bq);
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
 
 bool
diff --git a/src/compiler/nir/nir_opt_copy_prop_vars.c b/src/compiler/nir/nir_opt_copy_prop_vars.c
index 6d86f8598d1..f5117328ea0 100644
--- a/src/compiler/nir/nir_opt_copy_prop_vars.c
+++ b/src/compiler/nir/nir_opt_copy_prop_vars.c
@@ -1510,11 +1510,8 @@ nir_copy_prop_vars_impl(nir_function_impl *impl)
 
    copy_prop_vars_cf_node(&state, NULL, &impl->cf_node);
 
-   if (state.progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
+   bool impl_progress = state.progress;
+   nir_progress(impl_progress, impl, nir_metadata_control_flow);
 
    ralloc_free(mem_ctx);
    return state.progress;
diff --git a/src/compiler/nir/nir_opt_copy_propagate.c b/src/compiler/nir/nir_opt_copy_propagate.c
index c1725d2287d..be76b3287ae 100644
--- a/src/compiler/nir/nir_opt_copy_propagate.c
+++ b/src/compiler/nir/nir_opt_copy_propagate.c
@@ -157,13 +157,7 @@ nir_copy_prop_impl(nir_function_impl *impl)
       }
    }
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
 
 bool
diff --git a/src/compiler/nir/nir_opt_cse.c b/src/compiler/nir/nir_opt_cse.c
index e7271eb6b12..01c02640f8e 100644
--- a/src/compiler/nir/nir_opt_cse.c
+++ b/src/compiler/nir/nir_opt_cse.c
@@ -53,11 +53,7 @@ nir_opt_cse_impl(nir_function_impl *impl)
       }
    }
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
+   nir_progress(progress, impl, nir_metadata_control_flow);
 
    nir_instr_set_destroy(instr_set);
    return progress;
